##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate tilemap conversion from    ##
## original files (like Tiled .tmx) into C-arrays.                        ##
############################################################################

##
## NEW MACROS
##

# Default values
#$(eval $(call TMX2DATA, SET_ASMVARPREFIX, yes       ))   { yes, no      }
#$(eval $(call TMX2DATA, SET_USEMACROS   , yes       ))   { yes, no      }
#$(eval $(call TMX2DATA, SET_OUTPUTS     , h c       ))   { bin hs h s c }
#$(eval $(call TMX2DATA, SET_BASE        , dec       ))   { dec hex bin }
#$(eval $(call TMX2DATA, SET_BITSPERITEM , 8         ))   { 1, 2, 4, 6, 8 }
#$(eval $(call TMX2DATA, SET_FOLDER      , src/      )) 
#$(eval $(call TMX2DATA, SET_EXTRAPAR    ,           ))	
# Conversion 
#$(eval $(call TMX2DATA, CONVERT, tmxfile, array )) 

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl0)) 
$(eval $(call TMX2DATA, SET_OUTPUTS, hs  bin ))
$(eval $(call TMX2DATA, CONVERT, assets/lvl0.tmx, lvl0 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl1)) 
$(eval $(call TMX2DATA, CONVERT, assets/lvl1.tmx, lvl1 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl2))
$(eval $(call TMX2DATA, CONVERT, assets/lvl2.tmx, lvl2 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl3))
$(eval $(call TMX2DATA, CONVERT, assets/lvl3.tmx, lvl3 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl4))
$(eval $(call TMX2DATA, CONVERT, assets/lvl4.tmx, lvl4 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl5))
$(eval $(call TMX2DATA, CONVERT, assets/lvl5.tmx, lvl5 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl6))
$(eval $(call TMX2DATA, CONVERT, assets/lvl6.tmx, lvl6 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl7))
$(eval $(call TMX2DATA, CONVERT, assets/lvl7.tmx, lvl7 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl8))
$(eval $(call TMX2DATA, CONVERT, assets/lvl8.tmx, lvl8 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl9))
$(eval $(call TMX2DATA, CONVERT, assets/lvl9.tmx, lvl9 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl10))
$(eval $(call TMX2DATA, CONVERT, assets/lvl10.tmx, lvl10 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl11))
$(eval $(call TMX2DATA, CONVERT, assets/lvl11.tmx, lvl11 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl12))
$(eval $(call TMX2DATA, CONVERT, assets/lvl12.tmx, lvl12 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl13))
$(eval $(call TMX2DATA, CONVERT, assets/lvl13.tmx, lvl13 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl14))
$(eval $(call TMX2DATA, CONVERT, assets/lvl14.tmx, lvl14 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl15))
$(eval $(call TMX2DATA, CONVERT, assets/lvl15.tmx, lvl15 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl16))
$(eval $(call TMX2DATA, CONVERT, assets/lvl16.tmx, lvl16 ))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl17))
$(eval $(call TMX2DATA, CONVERT, assets/lvl17.tmx, lvl17))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl18))
$(eval $(call TMX2DATA, CONVERT, assets/lvl18.tmx, lvl18))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl19))
$(eval $(call TMX2DATA, CONVERT, assets/lvl19.tmx, lvl19))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl20))
$(eval $(call TMX2DATA, CONVERT, assets/lvl20.tmx, lvl20))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl21))
$(eval $(call TMX2DATA, CONVERT, assets/lvl21.tmx, lvl21))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl22))
$(eval $(call TMX2DATA, CONVERT, assets/lvl22.tmx, lvl22))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl23))
$(eval $(call TMX2DATA, CONVERT, assets/lvl23.tmx, lvl23))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl24))
$(eval $(call TMX2DATA, CONVERT, assets/lvl24.tmx, lvl24))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl25))
$(eval $(call TMX2DATA, CONVERT, assets/lvl25.tmx, lvl25))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl26))
$(eval $(call TMX2DATA, CONVERT, assets/lvl26.tmx, lvl26))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl27))
$(eval $(call TMX2DATA, CONVERT, assets/lvl27.tmx, lvl27))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl28))
$(eval $(call TMX2DATA, CONVERT, assets/lvl28.tmx, lvl28))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl29))
$(eval $(call TMX2DATA, CONVERT, assets/lvl29.tmx, lvl29))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl30))
$(eval $(call TMX2DATA, CONVERT, assets/lvl30.tmx, lvl30))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl31))
$(eval $(call TMX2DATA, CONVERT, assets/lvl31.tmx, lvl31))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl32))
$(eval $(call TMX2DATA, CONVERT, assets/lvl32.tmx, lvl32))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl33))
$(eval $(call TMX2DATA, CONVERT, assets/lvl33.tmx, lvl33))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl34))
$(eval $(call TMX2DATA, CONVERT, assets/lvl34.tmx, lvl34))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl35))
$(eval $(call TMX2DATA, CONVERT, assets/lvl35.tmx, lvl35))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl36))
$(eval $(call TMX2DATA, CONVERT, assets/lvl36.tmx, lvl36))

$(eval $(call TMX2DATA, SET_FOLDER      , src/maps/lvl37))
$(eval $(call TMX2DATA, CONVERT, assets/lvl37.tmx, lvl37))

##
## OLD MACROS (For compatibility)
##

## TILEMAP CONVERSION EXAMPLES (Uncomment EVAL lines to use)
##

## Convert img/tilemap.tmx to src/tilemap.c and src/tilemap.h
##		This file contains a tilemap created with Tiled that uses tiles
## in img/tiles.png. This macro will convert the tilemap into a C-array
## named g_tilemap, containing all the IDs of the tiles that are located 
## at each given location of the C-array. 
##

#$(eval $(call TMX2C,img/tilemap.tmx,g_tilemap,src/,4))

## Convert img/level0b.tmx to src/levels/level0b.c and src/levels/level0b.h
##		This file contains another tilemap created with Tiled. This macro 
## will convert the tilemap into a C bitarray of 4-bits per item. The array
## will be named g_level0_4bit. For each tile ID included into the final 
## bitarray, only 4 bits will be used. Therefore, each byte of the array 
## will contain 2 tile IDs.
##

#$(eval $(call TMX2C,img/level0b.tmx,g_level0_4bit,src/levels/,4))




############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is TMX2C, which has up to 4 parameters:      ##
##  (1): TMX file to be converted to C array                              ##
##  (2): C identifier for the generated C array                           ##
##  (3): Output folder for C and H files generated (Default same folder)  ##
##  (4): Bits per item (1,2,4 or 6 to codify tilemap into a bitarray).    ##
##       Blanck for normal integer tilemap array (8 bits per item)        ##
##  (5): Aditional options (aditional modifiers for cpct_tmx2csv)         ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call TMX2C,(1),(2),(3),(4),(5)))                             ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
